Index: uspace/lib/gfxfont/test/text.c
===================================================================
--- uspace/lib/gfxfont/test/text.c	(revision 7470d97aaec04abd08ce2ad450cda9e6ff912bd4)
+++ uspace/lib/gfxfont/test/text.c	(revision d63623f92e8437001fcbc1e4f07e8e87d5441222)
@@ -30,4 +30,5 @@
 #include <gfx/context.h>
 #include <gfx/font.h>
+#include <gfx/glyph.h>
 #include <gfx/text.h>
 #include <gfx/typeface.h>
@@ -144,4 +145,210 @@
 	gfx_typeface_destroy(tface);
 	gfx_color_delete(color);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** gfx_text_start_pos() correctly computes text start position */
+PCUT_TEST(text_start_pos)
+{
+	gfx_font_props_t props;
+	gfx_font_metrics_t metrics;
+	gfx_typeface_t *tface;
+	gfx_font_t *font;
+	gfx_context_t *gc;
+	gfx_color_t *color;
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t pos;
+	test_gc_t tgc;
+	errno_t rc;
+
+	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_color_new_rgb_i16(0, 0, 0, &color);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_typeface_create(gc, &tface);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_font_props_init(&props);
+	gfx_font_metrics_init(&metrics);
+	metrics.ascent = 10; // XXX
+	metrics.descent = 10; // XXX
+	rc = gfx_font_create(tface, &props, &metrics, &font);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_text_fmt_init(&fmt);
+	fmt.color = color;
+	pos.x = 0;
+	pos.y = 0;
+
+	rc = gfx_puttext(font, &pos, &fmt, "Hello world!");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_font_close(font);
+	gfx_typeface_destroy(tface);
+	gfx_color_delete(color);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** gfx_text_find_pos() finds position in text */
+PCUT_TEST(text_find_pos)
+{
+	gfx_font_props_t props;
+	gfx_font_metrics_t metrics;
+	gfx_typeface_t *tface;
+	gfx_font_t *font;
+	gfx_glyph_metrics_t gmetrics;
+	gfx_glyph_t *glyph1;
+	gfx_glyph_t *glyph2;
+	gfx_context_t *gc;
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t anchor;
+	gfx_coord2_t fpos;
+	size_t off;
+	test_gc_t tgc;
+	errno_t rc;
+
+	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_typeface_create(gc, &tface);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_font_props_init(&props);
+	gfx_font_metrics_init(&metrics);
+	rc = gfx_font_create(tface, &props, &metrics, &font);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Need to create some glyphs with metrics */
+	gfx_glyph_metrics_init(&gmetrics);
+	gmetrics.advance = 10;
+
+	rc = gfx_glyph_create(font, &gmetrics, &glyph1);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_glyph_set_pattern(glyph1, "A");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_glyph_metrics_init(&gmetrics);
+	gmetrics.advance = 1;
+
+	rc = gfx_glyph_create(font, &gmetrics, &glyph2);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_glyph_set_pattern(glyph2, "i");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	gfx_text_fmt_init(&fmt);
+	anchor.x = 10;
+	anchor.y = 0;
+
+	fpos.x = 9;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(0, off);
+
+	fpos.x = 10;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(0, off);
+
+	fpos.x = 11;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(0, off);
+
+	fpos.x = 19;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(1, off);
+
+	fpos.x = 20;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(2, off);
+
+	fpos.x = 21;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(3, off);
+
+	fpos.x = 22;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	PCUT_ASSERT_INT_EQUALS(3, off);
+
+	gfx_glyph_destroy(glyph1);
+	gfx_glyph_destroy(glyph2);
+
+	gfx_font_close(font);
+	gfx_typeface_destroy(tface);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** gfx_text_find_pos() finds position in text in text mode */
+PCUT_TEST(text_find_pos_text)
+{
+	gfx_typeface_t *tface;
+	gfx_font_t *font;
+	gfx_context_t *gc;
+	test_gc_t tgc;
+	size_t off;
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t anchor;
+	gfx_coord2_t fpos;
+	errno_t rc;
+
+	rc = gfx_context_new(&test_ops, (void *)&tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_typeface_create(gc, &tface);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_font_create_textmode(tface, &font);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	anchor.x = 10;
+	anchor.y = 0;
+	gfx_text_fmt_init(&fmt);
+
+	fpos.x = 9;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(0, off);
+
+	fpos.x = 10;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(0, off);
+
+	fpos.x = 11;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(1, off);
+
+	fpos.x = 12;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(2, off);
+
+	fpos.x = 13;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(3, off);
+
+	fpos.x = 14;
+	fpos.y = 0;
+	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	PCUT_ASSERT_INT_EQUALS(3, off);
+
+	gfx_font_close(font);
+	gfx_typeface_destroy(tface);
 
 	rc = gfx_context_delete(gc);
